Bug 56055

Summary: Route is not extracted properly when a session cookie does not contain a dot
Product: Apache httpd-2 Reporter: jerrinot <jaromir.hamala>
Component: mod_proxy_balancerAssignee: Apache HTTPD Bugs Mailing List <bugs>
Status: RESOLVED LATER    
Severity: normal Keywords: MassUpdate
Priority: P2    
Version: 2.2-HEAD   
Target Milestone: ---   
Hardware: PC   
OS: Linux   

Description jerrinot 2014-01-23 10:19:53 UTC
Hi,

according to documentation: "The balancer extracts the value of the cookie and looks for a member worker with route equal to that value."

The documentation also says: "Some back-ends use a slightly different form of stickyness cookie, for instance Apache Tomcat. Tomcat adds the name of the Tomcat instance to the end of its session id cookie, separated with a dot (.) from the session id. Thus if the Apache web server finds a dot in the value of the stickyness cookie, it only uses the part behind the dot to search for the route."

Unfortunately it seems me http 2.2 does not consider the value from the cookie at all unless it contains the dot. It's probably caused by this line: https://github.com/apache/httpd/blob/2.2.x/modules/proxy/mod_proxy_balancer.c#L287

If *route does not contain a dot then the *route will be set to NULL, therefore the subsequent condition is false.
Comment 1 Maciej Deorowicz 2014-07-16 22:36:18 UTC
I could confirm this for 2.4.9 

Support for changing separator has been added in Bug 53893 (stickysessionsep parameter in mod_proxy). But still, when separator is missing the cookie is omitted.
Comment 2 William A. Rowe Jr. 2018-11-07 21:08:59 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.